#pragma once
class FloydWarshall
{
public:
	FloydWarshall();
	~FloydWarshall();


	void solve(std::vector<std::vector<double>> &g);
	double getCost(const int &u, const int &v);
	std::vector<int> getPathIdx(const int &u, const int &v);
	std::vector<CapturingReality::CoordinateSystemPoint> getPath(
		const int &u, const int &v,
		std::vector<std::vector<std::vector<CapturingReality::CoordinateSystemPoint>>> &pths);

private:
	const double INF = 1.79769e+308; //double MAX
	std::vector<std::vector<double>> dist, next;
};

